/// <reference types="node" />
import { Url } from 'url';
import { CommandUtil } from "../interfaces/command-util";
import { ForceErrorImpl } from "./force-error-impl";
import { SafeJson } from "../interfaces/safe-json";
import { RemoteCatalogGetter } from "../interfaces/remote-catalog/remote-catalog-getter";
export declare class RemoteCatalogGetterImpl extends ForceErrorImpl implements RemoteCatalogGetter {
    private commandUtil;
    private safeJson;
    constructor(commandUtil: CommandUtil, safeJson: SafeJson);
    getCatalogFromUrl(url: Url | string, cb: (err, remoteCatalog) => void): void;
    private getRemoteResource(url, parentCatalogEntryName, cb);
    resolveJsonObjectFromUrl(url: Url | string, cb: (err: Error, jsonObject: any, absoluteUrl: string) => void): void;
    resolveTextResourceFromUrl(url: Url | string, cb: (err: Error, text?: string, absoluteUrl?: string) => void): void;
    getParsedUrl(url: Url | string): Url;
}
