"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var child_process_1 = require("child_process");
var force_error_impl_1 = require("./force-error-impl");
var readlineSync = require('readline-sync');
var inpathSync = require('inpath').sync;
var pidof = require('pidof');
var psTree = require('ps-tree');
var SpawnImpl = (function (_super) {
    __extends(SpawnImpl, _super);
    function SpawnImpl(commandUtil) {
        var _this = _super.call(this) || this;
        _this.commandUtil = commandUtil;
        return _this;
    }
    SpawnImpl_1 = SpawnImpl;
    SpawnImpl.prototype.spawnShellCommandPipelineAsync = function (cmdArray, optionsArray, cbStatusOrFinal, cbFinal) {
        var lclCmdArray = cmdArray.slice(0);
        var lclOptionsArray = optionsArray.slice(0);
        var cmd = lclCmdArray.pop().slice(0);
        var childProcess = this.spawnShellCommandAsync(cmd, lclOptionsArray.pop(), cbStatusOrFinal, cbFinal);
        var proc = childProcess;
        while (cmd = lclCmdArray.pop()) {
            cmd = cmd.slice(0);
            var prevStdin = proc.stdin;
            proc = this.spawnShellCommandAsync(cmd, lclOptionsArray.pop(), cbStatusOrFinal, function (err, results) {
                process.stderr.write(results);
            });
            proc.stdout.pipe(prevStdin);
        }
        return childProcess;
    };
    SpawnImpl.prototype.sudoSpawnPipelineAsync = function (cmdArray, optionsArray, cbStatusOrFinal, cbFinal) {
        return undefined;
    };
    SpawnImpl.prototype.validate_spawnShellCommandAsync_args = function (cmd, options, cbStatus, cbFinal) {
        if (options === void 0) { options = null; }
        if (cbStatus === void 0) { cbStatus = null; }
        if (cbFinal === void 0) { cbFinal = null; }
        cmd = cmd || [];
        cmd = cmd.slice(0);
        if (typeof cbFinal !== 'function') {
            if (typeof cbStatus !== 'function') {
                cbFinal = cbStatus = function () {
                };
            }
            else {
                cbFinal = cbStatus;
                cbStatus = function () {
                };
            }
        }
        else {
            if (typeof cbStatus !== 'function') {
                cbStatus = function () {
                };
            }
        }
        options = options || {};
        options.preSpawnMessage = options.preSpawnMessage || '';
        options.postSpawnMessage = options.postSpawnMessage || '';
        options.showDiagnostics = options.showDiagnostics || false;
        options.suppressStdErr = options.suppressStdErr || false;
        options.suppressStdOut = options.suppressStdOut || false;
        options.cacheStdErr = options.cacheStdErr || false;
        options.cacheStdOut = options.cacheStdOut || false;
        options.suppressFinalStats = options.suppressFinalStats || false;
        options.stdio = options.stdio || 'pipe';
        options.cwd = options.cwd || process.cwd();
        return { cmd: cmd, options: options, cbStatus: cbStatus, cbFinal: cbFinal };
    };
    SpawnImpl.prototype.spawnShellCommandAsync = function (_cmd, _options, _cbStatus, _cbFinal) {
        if (_options === void 0) { _options = null; }
        if (_cbStatus === void 0) { _cbStatus = null; }
        if (_cbFinal === void 0) { _cbFinal = null; }
        var me = this;
        var _a = me.validate_spawnShellCommandAsync_args(_cmd, _options, _cbStatus, _cbFinal), cmd = _a.cmd, options = _a.options, cbStatus = _a.cbStatus, cbFinal = _a.cbFinal;
        if (me.checkForceError('spawnShellCommandAsync', cbFinal)) {
            return;
        }
        var childProcess;
        try {
            var command = cmd[0];
            var args = cmd.slice(1);
            var stdoutText_1 = '';
            var stderrText_1 = '';
            me.diagnosticTrace("Running '" + cmd + "' @ '" + options.cwd + "'", options);
            SpawnImpl_1.reportStatus(cbStatus, options.preSpawnMessage);
            childProcess = child_process_1.spawn(command, args, options);
            childProcess.stderr.on('data', function (dataChunk) {
                if (options.suppressStdErr && !options.cacheStdErr) {
                    return;
                }
                var text = dataChunk.toString();
                if (!options.suppressStdErr) {
                    cbStatus(new Error(text), text);
                }
                if (options.cacheStdErr) {
                    stderrText_1 += text;
                }
            });
            childProcess.stdout.on('data', function (dataChunk) {
                if (options.suppressStdOut && !options.cacheStdOut) {
                    return;
                }
                var text = dataChunk.toString();
                if (!options.suppressStdOut) {
                    cbStatus(null, text);
                }
                if (options.cacheStdOut) {
                    stdoutText_1 += text;
                }
            });
            childProcess.on('error', function (code) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, '', stdoutText_1, stderrText_1, options, cbStatus, cbFinal);
            });
            childProcess.on('exit', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal, stdoutText_1, stderrText_1, options, cbStatus, cbFinal);
            });
            childProcess.on('close', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal, stdoutText_1, stderrText_1, options, cbStatus, cbFinal);
            });
        }
        catch (err) {
            cbFinal(err, null);
        }
        return childProcess;
    };
    SpawnImpl.reportStatus = function (cbStatus, status) {
        if (!cbStatus || !status) {
            return;
        }
        cbStatus(null, status);
    };
    SpawnImpl.prototype.diagnosticTrace = function (msg, options) {
        if (!options.showDiagnostics) {
            return;
        }
        this.commandUtil.log(msg);
    };
    SpawnImpl.childCloseOrExit = function (code, signal, stdoutText, stderrText, options, cbStatus, cbFinal) {
        if (cbFinal) {
            SpawnImpl_1.reportStatus(cbStatus, options.postSpawnMessage);
            var returnString = !options.suppressFinalStats
                ? JSON.stringify({ code: code, signal: signal, stdoutText: stdoutText, stderrText: stderrText }, undefined, 2)
                : '';
            var error = (code !== null && code !== 0)
                ? new Error(returnString)
                : null;
            cbFinal(error, returnString);
        }
        return null;
    };
    SpawnImpl.prototype.sudoSpawnAsync = function (cmd, options, cbStatusOrFinal, cbFinal) {
        if (options === void 0) { options = null; }
        if (cbStatusOrFinal === void 0) { cbStatusOrFinal = null; }
        if (cbFinal === void 0) { cbFinal = null; }
        var me = this;
        var prompt = '#node-sudo-passwd#';
        var prompts = 0;
        var args = ['-S', '-p', prompt];
        cmd = cmd || [];
        cmd = cmd.slice(0);
        [].push.apply(args, cmd);
        var path = process.env['PATH'].split(':');
        var sudoBin = inpathSync('sudo', path);
        args.unshift(sudoBin);
        var child = me.spawnShellCommandAsync(args, options, cbStatusOrFinal, cbFinal);
        if (!child) {
            return;
        }
        function waitForStartup(err, children) {
            if (err) {
                throw new Error("Error spawning process");
            }
            if (children && children.length) {
                child.stderr.removeAllListeners();
            }
            else {
                setTimeout(function () {
                    psTree(child.pid, waitForStartup);
                }, 100);
            }
        }
        psTree(child.pid, waitForStartup);
        child.stderr.on('data', function (data) {
            var lines = data.toString().trim().split('\n');
            lines.forEach(function (line) {
                if (line === prompt) {
                    if (++prompts > 1) {
                        me.cachedPassword = null;
                    }
                    var username = require('username').sync();
                    var loginMessage = (prompts > 1)
                        ? "Sorry, try again.\n[sudo] password for " + username + ": "
                        : "[sudo] password for " + username + ": ";
                    if (me.cachedPassword) {
                        child.stdin.write(me.cachedPassword + '\n');
                    }
                    else {
                        me.cachedPassword = readlineSync.question(loginMessage, { hideEchoBack: true });
                        child.stdin.write(me.cachedPassword + '\n');
                    }
                }
            });
        });
        return child;
    };
    SpawnImpl = SpawnImpl_1 = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('CommandUtil')),
        __metadata("design:paramtypes", [Object])
    ], SpawnImpl);
    return SpawnImpl;
    var SpawnImpl_1;
}(force_error_impl_1.ForceErrorImpl));
exports.SpawnImpl = SpawnImpl;
//# sourceMappingURL=spawn-impl.js.map