"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var inversify_config_1 = require("../inversify.config");
var chai_1 = require("chai");
describe('SpawnAsync (no console out)', function () {
    var spawn;
    beforeEach(function (done) {
        spawn = inversify_config_1.default.get('Spawn');
        done();
    });
    afterEach(function (done) {
        spawn = null;
        done();
    });
    describe('spawnShellCommandPipelineAsync', function () {
        it('should', function (done) {
            chai_1.expect(spawn).to.not.equal(null);
            spawn.spawnShellCommandPipelineAsync([
                ["/home/jreeme/src/firmament-bash/js/test/helpers/test-00.js", "10", "Piping exercise -->"],
                ["/home/jreeme/src/firmament-bash/js/test/helpers/test-01.js", "Middle Text!->"],
                ["/home/jreeme/src/firmament-bash/js/test/helpers/test-02.js", "End Text!->"]
            ], null, function (err, result) {
                chai_1.expect(err).to.equal(null);
                spawn.commandUtil.stdoutWrite(result);
            }, function (err) {
                chai_1.expect(err).to.equal(null);
                done();
            });
        });
    });
});
//# sourceMappingURL=pipeline-async.test.js.map