"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var inversify_config_1 = require("../inversify.config");
var chai_1 = require("chai");
var nodeUrl = require("url");
describe('RemoteCatalog', function () {
    describe('create using kernel', function () {
        it('should be created by kernel (as singleton)', function (done) {
            var remoteCatalogGetter0 = inversify_config_1.default.get('RemoteCatalogGetter');
            var remoteCatalogGetter1 = inversify_config_1.default.get('RemoteCatalogGetter');
            chai_1.expect(remoteCatalogGetter0).to.equal(remoteCatalogGetter1);
            done();
        });
    });
    describe('getParsedUrl', function () {
        var remoteCatalogGetter = inversify_config_1.default.get('RemoteCatalogGetter');
        it('should return null Url when given null', function (done) {
            chai_1.expect(remoteCatalogGetter.getParsedUrl(null)).to.equal(null);
            done();
        });
        it('should return Url when given string', function (done) {
            var path = 'misty/morning';
            var parsedUrl = remoteCatalogGetter.getParsedUrl(path);
            chai_1.expect(parsedUrl.constructor.name).to.be.equal('Url');
            chai_1.expect(parsedUrl.path).to.equal(path);
            done();
        });
        it('should return input parameter when called with Url', function (done) {
            var url = nodeUrl.parse('http://www.global.net');
            var parsedUrl = remoteCatalogGetter.getParsedUrl(url);
            chai_1.expect(parsedUrl).to.be.equal(url);
            done();
        });
    });
});
//# sourceMappingURL=remote-catalog.test.js.map